<!DOCTYPE html>
<html>

<head>
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
</head>

<body>
  <div class="container">
    <h2>Registration Car Form</h2>

    <div class="jumbotron container">
      <div class="row form-group">
        <div class="col-sm-3">
          <label for="input-fname">First Name</label>
        </div>
        <div class="col-sm-9">
          <input type="text" id="input-fname" name="firstname" placeholder="Your first name ..." class="form-control">
        </div>
      </div>
      <div class="row form-group">
        <div class="col-sm-3">
          <label for="input-lname">Last Name</label>
        </div>
        <div class="col-sm-9">
          <input type="text" id="input-lname" name="lastname" placeholder="Your last name ..." class="form-control">
        </div>
      </div>
      <div class="row form-group">
        <div class="col-sm-3">
          <label for="country-select">Country</label>
        </div>
        <div class="col-sm-3">
          <select id="country-select" name="country" class="form-control">
          </select>
        </div>
        <div class="col-sm-3">
          <label for="region-type-select">Region</label>
        </div>
        <div class="col-sm-3">
          <select id="region-type-select" name="region" class="form-control">
          </select>
        </div>
      </div>
      <div class="row form-group">
        <div class="col-sm-3">
          <label for="car-select">Car</label>
        </div>
        <div class="col-sm-3">
          <select id="car-select" name="car" class="form-control">
          </select>
        </div>
        <div class="col-sm-3">
          <label for="car-type-select">Car type</label>
        </div>
        <div class="col-sm-3">
          <select id="car-type-select" name="car-type" disabled class="form-control">
          </select>
        </div>
      </div>
      <div class="row">
        <div class="col-sm-12" style="text-align: right;">
          <button class="btn btn-info" id="btn-send"> Send </button>
        </div>
      </div>
    </div>
  </div>
</body>

<script>
  "use strict";
  /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
  // car brand information
  var gJsonCarData = `[{"brandId": "0","brandName": "None", "brandTypes": []}, 
                    {"brandId": "1","brandName": "Audi", "brandTypes": [{"typeId":"0", "typeName":"Q3"},{"typeId":"1","typeName":"Q5"},{"typeId":"2","typeName":"A4"}]},
                    {"brandId": "2","brandName": "BMW", "brandTypes": [{"typeId":"0","typeName":"1 series"},{"typeId":"1","typeName":"X series"},{"typeId":"2","typeName":"Z series"}]},
                    {"brandId": "3","brandName": "Citroen", "brandTypes": [{"typeId":"0","typeName":"new C3"},{"typeId":"1","typeName":"C4"},{"typeId":"2","typeName":"BERLINGO"}]}]`;

  // country information
  var gJsonCountryData = `[{"countryId": "0","countryName": "None", "regionTypes": []}, 
                        {"countryId": "1","countryName": "Việt nam", "regionTypes": 
                                                [{"regionId":"0", "regionName":"Hà Nội"},
                                                 {"regionId":"1","regionName":"Hồ Chí Minh"},
                                                 {"regionId":"2","regionName":"Đà Nẵng"}]},
                        {"countryId": "2","countryName": "Mỹ", "regionTypes": 
                                                [{"regionId":"0","regionName":"Atlanta"},
                                                 {"regionId":"1","regionName":"New York"},
                                                 {"regionId":"2","regionName":"Boston"}]},
                        {"countryId": "3","countryName": "Phần lan", "regionTypes": 
                                                [{"regionId":"0","regionName":"Nam Phần Lan"},
                                                 {"regionId":"1","regionName":"Tây Phần Lan"},
                                                 {"regionId":"2","regionName":"Đông Phần Lan"}]}]`;

  var gObjectCarData = JSON.parse(gJsonCarData);

  /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
  $(document).ready(function () {
    // Gọi hàm để load dữ liệu vào ô Select Country khi trang được tải
    loadCountryData();

    // Gán sự kiện change cho ô Select Country
    $("#country-select").on("change", function () {
      onCountrySelectChange();
    });

    // Gán sự kiện click cho nút Send
    $("#btn-send").click(function () {
      onBtnSendClick();
    });
  });

  /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
  // Hàm xử lý khi ô Select Country thay đổi
  function onCountrySelectChange() {
    var countryId = $("#country-select").val();
    console.log("Selected Country ID: " + countryId);

    // Load dữ liệu Region tương ứng vào ô Select Region
    loadRegionData(countryId);
  }

  // Hàm xử lý khi nút Send được click
  function onBtnSendClick() {
    var countryId = $("#country-select").val();
    var countryName = $("#country-select option:selected").text();
    var regionId = $("#region-type-select").val();
    var regionName = $("#region-type-select option:selected").text();

    console.log("Country ID: " + countryId);
    console.log("Country Name: " + countryName);
    console.log("Region ID: " + regionId);
    console.log("Region Name: " + regionName);
  }

  /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
  // Hàm load dữ liệu vào ô Select Country
  function loadCountryData() {
    var countrySelect = $("#country-select");
    var countryData = JSON.parse(gJsonCountryData);

    for (var i = 0; i < countryData.length; i++) {
      var option = $("<option></option>");
      option.val(countryData[i].countryId);
      option.text(countryData[i].countryName);
      countrySelect.append(option);
    }
  }

  // Hàm load dữ liệu Region tương ứng vào ô Select Region dựa trên countryId
  function loadRegionData(countryId) {
    var regionSelect = $("#region-type-select");
    var countryData = JSON.parse(gJsonCountryData);

    // Tìm quốc gia được chọn trong dữ liệu
    var selectedCountry = countryData.find(function (country) {
      return country.countryId === countryId;
    });

    // Xóa các option cũ trong ô Select Region
    regionSelect.empty();

    // Thêm các option cho các vùng tương ứng của quốc gia được chọn
    for (var i = 0; i < selectedCountry.regionTypes.length; i++) {
      var option = $("<option></option>");
      option.val(selectedCountry.regionTypes[i].regionId);
      option.text(selectedCountry.regionTypes[i].regionName);
      regionSelect.append(option);
    }
  }

</script>

</html>